#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "datatypes.h"
#include "print.h"
#include "tools.h"

/*************************ASY{******************************/

void insert (BinaryTreeNode *node, int val) {
  if (val < node->val){
    if (node->left == NULL) {
      //Vm[hǉ
	node->left = malloc(sizeof(BinaryTreeNode));
	node->left->val = val;
	node->left->left = NULL;
	node->left->right = NULL;
    }
    else
      insert(node->left, val);          //̎qH
  }
  else {
    if (node->right == NULL) {
      //Vm[hǉ
	node->right = malloc(sizeof(BinaryTreeNode));
	node->right->val = val;
	node->right->left = NULL;
	node->right->right = NULL;
    }
    else
      insert(node->right, val);         //E̎qH
  }
}


/* 폜̃R[hBċAIɍ~ĂĖړȈꏊăm[h폜B
   폜ɂ deletemiňʂ𖄂ߍށB */
BinaryTreeNode *deletemin(BinaryTreeNode *node, BinaryTreeNode *parent){        //q̂̍ŏlƂĂ
  if (node->left == NULL){      // EɂqȂ
    if (parent->left == node)   // ĝꏊɉE̎qzu
      parent->left = node->right;
    else 
      parent->right = node->right;
    return node;	//gŏl
  }
  parent = node;
  node = node->left;
  while(node->left != NULL){	//̎qH
    parent =node;
    node = node->left;
  }
  parent->left = node->right;
  return node;
}	


BinaryTreeNode *delete (BinaryTreeNode *node, int val) {
  if (node == NULL)
    return NULL;
  if (val < node->val) {
    node->left = delete(node->left, val);  //̎qH
    return node;
  }
  else if (val > node->val){
    node->right =  delete(node->right, val); //E̎qH
    return node;
  }
  else {  // node폜
    if (node->left == NULL && node->right == NULL) {//@qȂ
      free(node);
      return NULL;
    }
    else if (node->left == NULL && node->right != NULL) { // E̎q̂
      BinaryTreeNode *tg = node->right;
      free(node);
      return tg;
    }
    else if (node->left != NULL && node->right == NULL)  { // ̎q̂
      BinaryTreeNode *tg = node->left;
      free(node);
      return tg;
    }
    else {                                               //qQ
      BinaryTreeNode *min = deletemin(node->right, node); //E̎q̍ŏl
      min->right = node->right;
      min->left = node->left;
      free(node);
      return min;
    }
  }
}

/**********************ASY{̂܂**************************/


void deleteTree (BinaryTreeNode *node) {
  if (node == NULL) return;
  deleteTree(node->left);
  deleteTree(node->right);
  free(node);
}


int main (int argc, char *argv[]) {
  char command;
  char fname[1024] = {0};
  int val;

  BinaryTreeNode *root = NULL;


  // Lecture
  fprintf(stderr, "********񕪒T********\n");
  fprintf(stderr, "R}hF\n");
  fprintf(stderr, "i [n] : ؂ɐn}\n");
  fprintf(stderr, "d [n] : ؂琮n폜\n");
  fprintf(stderr, "p : ؂̓e\\n");
  fprintf(stderr, "*************************\n");


  while (scanf("%c", &command) != EOF) {
    switch (command) {
    case 'i':
      scanf("%d", &val);
      if (root == NULL) {
	root = malloc(sizeof(BinaryTreeNode));
	root->val = val;
	root->left = NULL;
	root->right = NULL;
      } else
	insert(root, val);
      break;
    case 'd':
      scanf("%d", &val);
      root = delete(root, val);
      break;
    case 'p':
      printBinaryTree("BinaryTree", root, NULL, NULL);
      break;
    default:
      break;
    }
  }
  
  deleteTree(root);
  return 0;
}
