#include <stdio.h>
#include <stdlib.h>
#include "datatypes.h"
#include "print.h"
#include "tools.h"


static int *merge(int *array0, int size0, int *array1, int size1);

int *m_sort(int *array, int size){
  if (size == 0) // ċAĂяo̖[
    return NULL;
  if (size == 1) {
    int *ret = malloc(size * sizeof(int));
    ret[0] = array[0];
    return ret;
  }
		
  printArray("MergeSort_start", array, 0, size - 1, size/2, -1); //@\
		
  int *array0 = m_sort(array, size/2); // O\[g	
  int *array1 = m_sort(&array[size/2], size - (size / 2)); // 㔼\[g
  int *merged = merge(array0, size / 2, array1, size - (size / 2)); // }[W

  free(array0);
  free(array1);
  printArray("MergeSort_merged", merged, 0, size - 1, -1, -1); //@\
		
  return merged;
}

// Q{̃\[gς݃Xg}[WĂP{̃\[gς݃Xgɂ
// 擪瑖ĂďƂĂ
static int *merge(int *array0, int size0, int *array1, int size1){
  int i = 0, j = 0, k = 0;
  int *result = malloc((size0 + size1) * sizeof(int));
  while (1) {
    if (i < size0 && (j >= size1 || array0[i] <= array1[j])) {
      result[k++] = array0[i++];
    }
    if (j < size1 && (i >= size0 || array0[i] > array1[j])) { 
      result[k++] = array1[j++];
    }
    if (i == size0 && j == size1)
      return result;
  }
}
