#include <stdio.h>
#include <stdlib.h>
#include "datatypes.h"
#include "print.h"
#include "tools.h"


static int partition(int* array, int l, int r, int pivot);
static int find_pivot(int* array, int l, int r);
static void q_sort(int* array, int size, int i, int j);

// NCbN\[g̊ǑĂяo (R[h)
void quicksort (int *array, int size) {
  q_sort(array, size, 0, size - 1);
}


// NbN\[g̃C (R[h)
static void q_sort(int* array, int size, int i, int j) {
  if (i == j) // ċAĂяo̖[
    return;

  printArray("QuickSort_Itr_start", array, 0, size - 1, i, j); //@\

  int pivot = find_pivot(array, i, j); // s{bǧvZ
  if (pivot < 0) return; // Sēl
  int k = partition(array, i, j, pivot); // s{bg菬Ƒɕ

  printArray("QuickSort_Partitioned", array, 0, size - 1, k, -1); //@\

  q_sort(array, size, i, k - 1); // \[g
  q_sort(array, size, k, j); // 傫\[g

  printArray("QuickSort_Itr_end", array, 0, size - 1, i, j); //@\
}

// s{bǧvZ  l`r̊ԂōŏɏoĂQ̈قȂl̂傫Ԃ
static int find_pivot(int* array, int l, int r) {
  //@
  //@ɐR[h
  //
		
  // ȉ̓_~[̃R[h
  return array[l]; // Ƃ肠ŏ̂̂Ԃ
}

// s{bg菬Ƒɕ
// EU߂Ăċt]ЂԂĂB
//@Ԃl͐U蕪Ƃ̋ڂ̏ꏊ
static int partition(int* array, int l, int r, int pivot) {
  //@
  //@ɐR[h
  //
  // ȉ̓_~[̃R[h
  swapArray(array, l, r); // Ƃ肠lԖڂrԖڂ̗vfւ
  return (l+r+1)/2;// lr̐^񒆂Ԃ
}



