#ifndef DATA_TYPES_H
#define DATA_TYPES_H

typedef struct {
  int size;
  int last;
  int *data;
} Heap;

typedef struct BinaryTreeNode_ {
  struct BinaryTreeNode_ *left;
  struct BinaryTreeNode_ *right;
  int val;
} BinaryTreeNode;

struct MFSet_;

typedef struct MFSetNode_ {
  struct MFSetNode_ *parent;
  struct MFSet_ *set;
  int val;

  struct MFSetNode_ **children; // For Printing
} MFSetNode;

typedef struct MFSet_ {
  struct MFSetNode_ *root;
  int size;
} MFSet;

#endif
