#ifndef PRINT_H
#define PRINT_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "datatypes.h"

void printArray(char *label, int *array, int start, int end, int m1, int m2);

void printBinaryTree (char *label, BinaryTreeNode *node,
		      BinaryTreeNode *marker1, BinaryTreeNode *marker2);

void printMFSets (char *label, 
		  MFSet **sets, MFSetNode **val_to_node, int size,
		  MFSetNode *marker1, MFSetNode *marker2);

void printErrMessage(char *message, char *detail);

#endif
