#include <stdio.h>
#include <stdlib.h>
#include "datatypes.h"
#include "print.h"
#include "tools.h"


static int partition(int* array, int l, int r, int pivot);
static int find_pivot(int* array, int l, int r);
static void q_sort(int* array, int size, int i, int j);

void quicksort (int *array, int size) {
  q_sort(array, size, 0, size - 1);
}


static void q_sort(int* array, int size, int i, int j) {
  if (i == j) // ċAĂяo̖[
    return;

  printArray("QuickSort_Itr_start", array, 0, size - 1, i, j); //@\

  int pivot = find_pivot(array, i, j); // s{bǧvZ
  if (pivot < 0) return; // Sēl
  int k = partition(array, i, j, pivot); // s{bg菬Ƒɕ

  printArray("QuickSort_Partitioned", array, 0, size - 1, k, -1); //@\

  q_sort(array, size, i, k - 1); // \[g
  q_sort(array, size, k, j); // 傫\[g

  printArray("QuickSort_Itr_end", array, 0, size - 1, i, j); //@\
}

// s{bǧvZ  l`r̊ԂōŏɏoĂQ̈قȂl̂傫Ԃ
static int find_pivot(int* array, int l, int r) {
  int i;
  for (i = l + 1; i <= r; i++) {
    if (array[i] > array[l])
      return array[i];
    else if (array[i] < array[l])
      return array[l];
  }
  return -1;
}

// s{bg菬Ƒɕ
// EU߂Ăċt]ЂԂĂB
static int partition(int* array, int l, int r, int pivot) {
  while (1) {
    while (array[l] < pivot)
      l = l + 1;
    while (array[r] >= pivot)
      r = r - 1;
    if (l > r)
      return l;
    swapArray(array, l, r); // lԖڂrԖڂ̗vfւ
  }
}
