#include <stdio.h>
#include <stdlib.h>
#include "datatypes.h"
#include "print.h"
#include "tools.h"


/*************************ASY{******************************/

void insert (Heap *heap, int val) {
  int* data = heap->data;

  // data check
  if (heap->last + 1 >= heap->size) {
    printErrMessage("Insertion Failed.", "Heap is full.");
    return;
  }

  // Ōɗvfǉ (R[h)
  ++(heap->last);
  data[heap->last] = val;
  int i = heap->last;


  // ւƒHȂt]Ă
  //
  //	ɃR[h
  //
  // ȉA_~[̃R[h@eƂЂƂւ
  if (heap->last >= 1){
    printArray("Heap_insert", heap->data, 0, heap->last, (i - 1) / 2, i); // \
    swapArray(data, (heap->last - 1) / 2, heap->last);	//ւ
  }

}



int deletemin (Heap *heap) {
  int *data = heap->data;

  // data check
  if (heap->last < 0) {
    printErrMessage("Deletion Failed.", "Heap is empty.");
    return -1;
  }

  // ̗vfo(R[h)
  int val = data[0];
  // ŌɎĂ(R[h)
  data[0] = data[heap->last];
  --(heap->last);

  // ւƒHȂt]Ă
  //
  //	ɃR[h
  //
  // ȉA_~[̃R[h@qƂЂƂւ
  int i = 0;
  printArray("Heap_deletemin", heap->data, 0, heap->last, i, i * 2 + 2); //@\
  swapArray(data, i, i * 2 + 2); //E̎qƌ

  return val;
}

/**********************ASY{̂܂**************************/



int main (int argc, char *argv[]) {
  char command;
  int val;

  if (argc != 2) {
    printf("g: %s heapsize(őf[^)\n", argv[0]);
    return 0;
  }

  // Lecture
  fprintf(stderr, "**********q[v**********\n");
  fprintf(stderr, "R}hF\n");
  fprintf(stderr, "i [n] : q[vɐn}\n");
  fprintf(stderr, "d : q[vŏloĕ\\n");
  fprintf(stderr, "p : q[v̓e\\n");
  fprintf(stderr, "*************************\n");

  Heap *heap = malloc(sizeof(Heap));
  heap->size = atoi(argv[1]);
  heap->last = -1;
  heap->data = malloc(sizeof(int) * heap->size);

  while (scanf("%c", &command) != EOF) {
    switch (command) {
    case 'i':
      scanf("%d", &val);
      insert(heap, val);
      break;
    case 'd':
      val = deletemin(heap);
      printf("min: %d", val);
      break;
    case 'p':
      printArray("Heap", heap->data, 0, heap->last, -1, -1);
      break;
    default:
      break;
    }
  }
  
  free(heap->data);
  free(heap);
  return 0;
}
